// $ANTLR 3.5 /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g 2014-09-04 10:23:43

package uk.ac.ox.eolo.cqparser;

import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Set;

import uk.ac.ox.eolo.model.ConjunctiveQuery;
import uk.ac.ox.eolo.cqparser.ConjunctiveQueryWalker;


import uk.ac.ox.eolo.exception.IllegalInputQueryException;





import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

import org.antlr.runtime.tree.*;


@SuppressWarnings("all")
public class ConjunctiveQueryParser extends Parser {
	public static final String[] tokenNames = new String[] {
		"<invalid>", "<EOR>", "<DOWN>", "<UP>", "ATOM", "ATOM_LIST", "CONSTANT", 
		"EXPRESSION", "HEADATOM", "ID", "PREDICATE", "PREFIX", "PREFIX_LIST", 
		"RULE", "SCONSTANT", "STRING", "TERM_LIST", "URLSTRING", "VARIABLE", "WS", 
		"'('", "')'", "','", "'.'", "':'", "':-'", "'<-'", "'?'", "'PREFIX'", 
		"'prefix'"
	};
	public static final int EOF=-1;
	public static final int T__20=20;
	public static final int T__21=21;
	public static final int T__22=22;
	public static final int T__23=23;
	public static final int T__24=24;
	public static final int T__25=25;
	public static final int T__26=26;
	public static final int T__27=27;
	public static final int T__28=28;
	public static final int T__29=29;
	public static final int ATOM=4;
	public static final int ATOM_LIST=5;
	public static final int CONSTANT=6;
	public static final int EXPRESSION=7;
	public static final int HEADATOM=8;
	public static final int ID=9;
	public static final int PREDICATE=10;
	public static final int PREFIX=11;
	public static final int PREFIX_LIST=12;
	public static final int RULE=13;
	public static final int SCONSTANT=14;
	public static final int STRING=15;
	public static final int TERM_LIST=16;
	public static final int URLSTRING=17;
	public static final int VARIABLE=18;
	public static final int WS=19;

	// delegates
	public Parser[] getDelegates() {
		return new Parser[] {};
	}

	// delegators


	public ConjunctiveQueryParser(TokenStream input) {
		this(input, new RecognizerSharedState());
	}
	public ConjunctiveQueryParser(TokenStream input, RecognizerSharedState state) {
		super(input, state);
	}

	protected TreeAdaptor adaptor = new CommonTreeAdaptor();

	public void setTreeAdaptor(TreeAdaptor adaptor) {
		this.adaptor = adaptor;
	}
	public TreeAdaptor getTreeAdaptor() {
		return adaptor;
	}
	@Override public String[] getTokenNames() { return ConjunctiveQueryParser.tokenNames; }
	@Override public String getGrammarFileName() { return "/Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g"; }




	      
	      public ConjunctiveQueryParser(String string)
	        throws FileNotFoundException, IOException {
	        this(new CommonTokenStream(new ConjunctiveQueryLexer(new ANTLRStringStream(string))));
	      }
	  
	      public ConjunctiveQueryParser(InputStream istream) throws FileNotFoundException, IOException {
	        this(new CommonTokenStream(new ConjunctiveQueryLexer(new ANTLRInputStream(istream))));

	      }
	  
	  
	      public ConjunctiveQueryParser(File file) throws FileNotFoundException, IOException {
	        this(new CommonTokenStream(new ConjunctiveQueryLexer(new ANTLRInputStream(new FileInputStream(file)))));

	      }

	      public ConjunctiveQuery parse() throws IllegalInputQueryException {
	        cq_return r = null;
	        try {
	          r = cq();
	        } catch (RecognitionException e) {
	          e.printStackTrace();
	        }
	        CommonTree t = (CommonTree) r.getTree();

	        //System.out.println(t.toStringTree());
	        CommonTreeNodeStream nodes = new CommonTreeNodeStream(t);
	        // AST nodes have payloads that point into token stream
	        nodes.setTokenStream(input);


	        ConjunctiveQueryWalker walker = new ConjunctiveQueryWalker();

	        ConjunctiveQuery cq = walker.walkExpressionNode(t);
	        return cq;
	      }
	      
	      public ConjunctiveQuery parseCQ() throws IllegalInputQueryException {
	        return parse();
	      }
	      


	public static class cq_return extends ParserRuleReturnScope {
		Object tree;
		@Override
		public Object getTree() { return tree; }
	};


	// $ANTLR start "cq"
	// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:97:1: cq : prefixlist rulebody -> ^( EXPRESSION prefixlist rulebody ) ;
	public final ConjunctiveQueryParser.cq_return cq() throws RecognitionException {
		ConjunctiveQueryParser.cq_return retval = new ConjunctiveQueryParser.cq_return();
		retval.start = input.LT(1);

		Object root_0 = null;

		ParserRuleReturnScope prefixlist1 =null;
		ParserRuleReturnScope rulebody2 =null;

		RewriteRuleSubtreeStream stream_prefixlist=new RewriteRuleSubtreeStream(adaptor,"rule prefixlist");
		RewriteRuleSubtreeStream stream_rulebody=new RewriteRuleSubtreeStream(adaptor,"rule rulebody");

		try {
			// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:97:4: ( prefixlist rulebody -> ^( EXPRESSION prefixlist rulebody ) )
			// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:98:3: prefixlist rulebody
			{
			pushFollow(FOLLOW_prefixlist_in_cq133);
			prefixlist1=prefixlist();
			state._fsp--;

			stream_prefixlist.add(prefixlist1.getTree());
			pushFollow(FOLLOW_rulebody_in_cq135);
			rulebody2=rulebody();
			state._fsp--;

			stream_rulebody.add(rulebody2.getTree());
			// AST REWRITE
			// elements: rulebody, prefixlist
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (Object)adaptor.nil();
			// 98:23: -> ^( EXPRESSION prefixlist rulebody )
			{
				// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:98:26: ^( EXPRESSION prefixlist rulebody )
				{
				Object root_1 = (Object)adaptor.nil();
				root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(EXPRESSION, "EXPRESSION"), root_1);
				adaptor.addChild(root_1, stream_prefixlist.nextTree());
				adaptor.addChild(root_1, stream_rulebody.nextTree());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (Object)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
			retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "cq"


	public static class prefixlist_return extends ParserRuleReturnScope {
		Object tree;
		@Override
		public Object getTree() { return tree; }
	};


	// $ANTLR start "prefixlist"
	// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:100:1: prefixlist : prefix ( ',' prefix )* -> ^( PREFIX_LIST ( prefix )* ) ;
	public final ConjunctiveQueryParser.prefixlist_return prefixlist() throws RecognitionException {
		ConjunctiveQueryParser.prefixlist_return retval = new ConjunctiveQueryParser.prefixlist_return();
		retval.start = input.LT(1);

		Object root_0 = null;

		Token char_literal4=null;
		ParserRuleReturnScope prefix3 =null;
		ParserRuleReturnScope prefix5 =null;

		Object char_literal4_tree=null;
		RewriteRuleTokenStream stream_22=new RewriteRuleTokenStream(adaptor,"token 22");
		RewriteRuleSubtreeStream stream_prefix=new RewriteRuleSubtreeStream(adaptor,"rule prefix");

		try {
			// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:100:11: ( prefix ( ',' prefix )* -> ^( PREFIX_LIST ( prefix )* ) )
			// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:101:3: prefix ( ',' prefix )*
			{
			pushFollow(FOLLOW_prefix_in_prefixlist155);
			prefix3=prefix();
			state._fsp--;

			stream_prefix.add(prefix3.getTree());
			// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:101:10: ( ',' prefix )*
			loop1:
			while (true) {
				int alt1=2;
				int LA1_0 = input.LA(1);
				if ( (LA1_0==22) ) {
					alt1=1;
				}

				switch (alt1) {
				case 1 :
					// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:101:11: ',' prefix
					{
					char_literal4=(Token)match(input,22,FOLLOW_22_in_prefixlist158);  
					stream_22.add(char_literal4);

					pushFollow(FOLLOW_prefix_in_prefixlist160);
					prefix5=prefix();
					state._fsp--;

					stream_prefix.add(prefix5.getTree());
					}
					break;

				default :
					break loop1;
				}
			}

			// AST REWRITE
			// elements: prefix
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (Object)adaptor.nil();
			// 101:24: -> ^( PREFIX_LIST ( prefix )* )
			{
				// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:101:27: ^( PREFIX_LIST ( prefix )* )
				{
				Object root_1 = (Object)adaptor.nil();
				root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(PREFIX_LIST, "PREFIX_LIST"), root_1);
				// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:101:41: ( prefix )*
				while ( stream_prefix.hasNext() ) {
					adaptor.addChild(root_1, stream_prefix.nextTree());
				}
				stream_prefix.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (Object)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
			retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "prefixlist"


	public static class prefix_return extends ParserRuleReturnScope {
		Object tree;
		@Override
		public Object getTree() { return tree; }
	};


	// $ANTLR start "prefix"
	// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:103:1: prefix : ( 'prefix' | 'PREFIX' ) id ':' url -> ^( PREFIX id url ) ;
	public final ConjunctiveQueryParser.prefix_return prefix() throws RecognitionException {
		ConjunctiveQueryParser.prefix_return retval = new ConjunctiveQueryParser.prefix_return();
		retval.start = input.LT(1);

		Object root_0 = null;

		Token string_literal6=null;
		Token string_literal7=null;
		Token char_literal9=null;
		ParserRuleReturnScope id8 =null;
		ParserRuleReturnScope url10 =null;

		Object string_literal6_tree=null;
		Object string_literal7_tree=null;
		Object char_literal9_tree=null;
		RewriteRuleTokenStream stream_24=new RewriteRuleTokenStream(adaptor,"token 24");
		RewriteRuleTokenStream stream_28=new RewriteRuleTokenStream(adaptor,"token 28");
		RewriteRuleTokenStream stream_29=new RewriteRuleTokenStream(adaptor,"token 29");
		RewriteRuleSubtreeStream stream_id=new RewriteRuleSubtreeStream(adaptor,"rule id");
		RewriteRuleSubtreeStream stream_url=new RewriteRuleSubtreeStream(adaptor,"rule url");

		try {
			// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:103:7: ( ( 'prefix' | 'PREFIX' ) id ':' url -> ^( PREFIX id url ) )
			// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:104:3: ( 'prefix' | 'PREFIX' ) id ':' url
			{
			// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:104:3: ( 'prefix' | 'PREFIX' )
			int alt2=2;
			int LA2_0 = input.LA(1);
			if ( (LA2_0==29) ) {
				alt2=1;
			}
			else if ( (LA2_0==28) ) {
				alt2=2;
			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 2, 0, input);
				throw nvae;
			}

			switch (alt2) {
				case 1 :
					// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:104:4: 'prefix'
					{
					string_literal6=(Token)match(input,29,FOLLOW_29_in_prefix183);  
					stream_29.add(string_literal6);

					}
					break;
				case 2 :
					// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:104:13: 'PREFIX'
					{
					string_literal7=(Token)match(input,28,FOLLOW_28_in_prefix185);  
					stream_28.add(string_literal7);

					}
					break;

			}

			pushFollow(FOLLOW_id_in_prefix188);
			id8=id();
			state._fsp--;

			stream_id.add(id8.getTree());
			char_literal9=(Token)match(input,24,FOLLOW_24_in_prefix190);  
			stream_24.add(char_literal9);

			pushFollow(FOLLOW_url_in_prefix193);
			url10=url();
			state._fsp--;

			stream_url.add(url10.getTree());
			// AST REWRITE
			// elements: url, id
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (Object)adaptor.nil();
			// 104:35: -> ^( PREFIX id url )
			{
				// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:104:38: ^( PREFIX id url )
				{
				Object root_1 = (Object)adaptor.nil();
				root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(PREFIX, "PREFIX"), root_1);
				adaptor.addChild(root_1, stream_id.nextTree());
				adaptor.addChild(root_1, stream_url.nextTree());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (Object)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
			retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "prefix"


	public static class rulebody_return extends ParserRuleReturnScope {
		Object tree;
		@Override
		public Object getTree() { return tree; }
	};


	// $ANTLR start "rulebody"
	// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:107:1: rulebody : headatom ( '<-' | ':-' ) body ( '.' )? -> ^( RULE headatom body ) ;
	public final ConjunctiveQueryParser.rulebody_return rulebody() throws RecognitionException {
		ConjunctiveQueryParser.rulebody_return retval = new ConjunctiveQueryParser.rulebody_return();
		retval.start = input.LT(1);

		Object root_0 = null;

		Token string_literal12=null;
		Token string_literal13=null;
		Token char_literal15=null;
		ParserRuleReturnScope headatom11 =null;
		ParserRuleReturnScope body14 =null;

		Object string_literal12_tree=null;
		Object string_literal13_tree=null;
		Object char_literal15_tree=null;
		RewriteRuleTokenStream stream_23=new RewriteRuleTokenStream(adaptor,"token 23");
		RewriteRuleTokenStream stream_25=new RewriteRuleTokenStream(adaptor,"token 25");
		RewriteRuleTokenStream stream_26=new RewriteRuleTokenStream(adaptor,"token 26");
		RewriteRuleSubtreeStream stream_headatom=new RewriteRuleSubtreeStream(adaptor,"rule headatom");
		RewriteRuleSubtreeStream stream_body=new RewriteRuleSubtreeStream(adaptor,"rule body");

		try {
			// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:107:9: ( headatom ( '<-' | ':-' ) body ( '.' )? -> ^( RULE headatom body ) )
			// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:108:3: headatom ( '<-' | ':-' ) body ( '.' )?
			{
			pushFollow(FOLLOW_headatom_in_rulebody215);
			headatom11=headatom();
			state._fsp--;

			stream_headatom.add(headatom11.getTree());
			// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:108:12: ( '<-' | ':-' )
			int alt3=2;
			int LA3_0 = input.LA(1);
			if ( (LA3_0==26) ) {
				alt3=1;
			}
			else if ( (LA3_0==25) ) {
				alt3=2;
			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 3, 0, input);
				throw nvae;
			}

			switch (alt3) {
				case 1 :
					// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:108:13: '<-'
					{
					string_literal12=(Token)match(input,26,FOLLOW_26_in_rulebody218);  
					stream_26.add(string_literal12);

					}
					break;
				case 2 :
					// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:108:18: ':-'
					{
					string_literal13=(Token)match(input,25,FOLLOW_25_in_rulebody220);  
					stream_25.add(string_literal13);

					}
					break;

			}

			pushFollow(FOLLOW_body_in_rulebody223);
			body14=body();
			state._fsp--;

			stream_body.add(body14.getTree());
			// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:108:29: ( '.' )?
			int alt4=2;
			int LA4_0 = input.LA(1);
			if ( (LA4_0==23) ) {
				alt4=1;
			}
			switch (alt4) {
				case 1 :
					// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:108:29: '.'
					{
					char_literal15=(Token)match(input,23,FOLLOW_23_in_rulebody225);  
					stream_23.add(char_literal15);

					}
					break;

			}

			// AST REWRITE
			// elements: headatom, body
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (Object)adaptor.nil();
			// 108:35: -> ^( RULE headatom body )
			{
				// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:108:38: ^( RULE headatom body )
				{
				Object root_1 = (Object)adaptor.nil();
				root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(RULE, "RULE"), root_1);
				adaptor.addChild(root_1, stream_headatom.nextTree());
				adaptor.addChild(root_1, stream_body.nextTree());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (Object)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
			retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "rulebody"


	public static class body_return extends ParserRuleReturnScope {
		Object tree;
		@Override
		public Object getTree() { return tree; }
	};


	// $ANTLR start "body"
	// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:110:1: body : atom ( ',' atom )* -> ^( ATOM_LIST ( atom )* ) ;
	public final ConjunctiveQueryParser.body_return body() throws RecognitionException {
		ConjunctiveQueryParser.body_return retval = new ConjunctiveQueryParser.body_return();
		retval.start = input.LT(1);

		Object root_0 = null;

		Token char_literal17=null;
		ParserRuleReturnScope atom16 =null;
		ParserRuleReturnScope atom18 =null;

		Object char_literal17_tree=null;
		RewriteRuleTokenStream stream_22=new RewriteRuleTokenStream(adaptor,"token 22");
		RewriteRuleSubtreeStream stream_atom=new RewriteRuleSubtreeStream(adaptor,"rule atom");

		try {
			// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:110:5: ( atom ( ',' atom )* -> ^( ATOM_LIST ( atom )* ) )
			// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:111:3: atom ( ',' atom )*
			{
			pushFollow(FOLLOW_atom_in_body247);
			atom16=atom();
			state._fsp--;

			stream_atom.add(atom16.getTree());
			// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:111:8: ( ',' atom )*
			loop5:
			while (true) {
				int alt5=2;
				int LA5_0 = input.LA(1);
				if ( (LA5_0==22) ) {
					alt5=1;
				}

				switch (alt5) {
				case 1 :
					// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:111:9: ',' atom
					{
					char_literal17=(Token)match(input,22,FOLLOW_22_in_body250);  
					stream_22.add(char_literal17);

					pushFollow(FOLLOW_atom_in_body252);
					atom18=atom();
					state._fsp--;

					stream_atom.add(atom18.getTree());
					}
					break;

				default :
					break loop5;
				}
			}

			// AST REWRITE
			// elements: atom
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (Object)adaptor.nil();
			// 111:20: -> ^( ATOM_LIST ( atom )* )
			{
				// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:111:23: ^( ATOM_LIST ( atom )* )
				{
				Object root_1 = (Object)adaptor.nil();
				root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(ATOM_LIST, "ATOM_LIST"), root_1);
				// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:111:35: ( atom )*
				while ( stream_atom.hasNext() ) {
					adaptor.addChild(root_1, stream_atom.nextTree());
				}
				stream_atom.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (Object)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
			retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "body"


	public static class headatom_return extends ParserRuleReturnScope {
		Object tree;
		@Override
		public Object getTree() { return tree; }
	};


	// $ANTLR start "headatom"
	// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:114:1: headatom : id '(' term ( ',' term )* ')' -> ^( HEADATOM ( term )* ) ;
	public final ConjunctiveQueryParser.headatom_return headatom() throws RecognitionException {
		ConjunctiveQueryParser.headatom_return retval = new ConjunctiveQueryParser.headatom_return();
		retval.start = input.LT(1);

		Object root_0 = null;

		Token char_literal20=null;
		Token char_literal22=null;
		Token char_literal24=null;
		ParserRuleReturnScope id19 =null;
		ParserRuleReturnScope term21 =null;
		ParserRuleReturnScope term23 =null;

		Object char_literal20_tree=null;
		Object char_literal22_tree=null;
		Object char_literal24_tree=null;
		RewriteRuleTokenStream stream_22=new RewriteRuleTokenStream(adaptor,"token 22");
		RewriteRuleTokenStream stream_20=new RewriteRuleTokenStream(adaptor,"token 20");
		RewriteRuleTokenStream stream_21=new RewriteRuleTokenStream(adaptor,"token 21");
		RewriteRuleSubtreeStream stream_term=new RewriteRuleSubtreeStream(adaptor,"rule term");
		RewriteRuleSubtreeStream stream_id=new RewriteRuleSubtreeStream(adaptor,"rule id");

		try {
			// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:114:9: ( id '(' term ( ',' term )* ')' -> ^( HEADATOM ( term )* ) )
			// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:115:3: id '(' term ( ',' term )* ')'
			{
			pushFollow(FOLLOW_id_in_headatom278);
			id19=id();
			state._fsp--;

			stream_id.add(id19.getTree());
			char_literal20=(Token)match(input,20,FOLLOW_20_in_headatom280);  
			stream_20.add(char_literal20);

			pushFollow(FOLLOW_term_in_headatom282);
			term21=term();
			state._fsp--;

			stream_term.add(term21.getTree());
			// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:115:15: ( ',' term )*
			loop6:
			while (true) {
				int alt6=2;
				int LA6_0 = input.LA(1);
				if ( (LA6_0==22) ) {
					alt6=1;
				}

				switch (alt6) {
				case 1 :
					// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:115:16: ',' term
					{
					char_literal22=(Token)match(input,22,FOLLOW_22_in_headatom285);  
					stream_22.add(char_literal22);

					pushFollow(FOLLOW_term_in_headatom287);
					term23=term();
					state._fsp--;

					stream_term.add(term23.getTree());
					}
					break;

				default :
					break loop6;
				}
			}

			char_literal24=(Token)match(input,21,FOLLOW_21_in_headatom291);  
			stream_21.add(char_literal24);

			// AST REWRITE
			// elements: term
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (Object)adaptor.nil();
			// 115:31: -> ^( HEADATOM ( term )* )
			{
				// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:115:34: ^( HEADATOM ( term )* )
				{
				Object root_1 = (Object)adaptor.nil();
				root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(HEADATOM, "HEADATOM"), root_1);
				// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:115:45: ( term )*
				while ( stream_term.hasNext() ) {
					adaptor.addChild(root_1, stream_term.nextTree());
				}
				stream_term.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (Object)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
			retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "headatom"


	public static class atom_return extends ParserRuleReturnScope {
		Object tree;
		@Override
		public Object getTree() { return tree; }
	};


	// $ANTLR start "atom"
	// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:117:1: atom : compositeid '(' term ( ',' term )* ')' -> ^( ATOM compositeid ( term )* ) ;
	public final ConjunctiveQueryParser.atom_return atom() throws RecognitionException {
		ConjunctiveQueryParser.atom_return retval = new ConjunctiveQueryParser.atom_return();
		retval.start = input.LT(1);

		Object root_0 = null;

		Token char_literal26=null;
		Token char_literal28=null;
		Token char_literal30=null;
		ParserRuleReturnScope compositeid25 =null;
		ParserRuleReturnScope term27 =null;
		ParserRuleReturnScope term29 =null;

		Object char_literal26_tree=null;
		Object char_literal28_tree=null;
		Object char_literal30_tree=null;
		RewriteRuleTokenStream stream_22=new RewriteRuleTokenStream(adaptor,"token 22");
		RewriteRuleTokenStream stream_20=new RewriteRuleTokenStream(adaptor,"token 20");
		RewriteRuleTokenStream stream_21=new RewriteRuleTokenStream(adaptor,"token 21");
		RewriteRuleSubtreeStream stream_term=new RewriteRuleSubtreeStream(adaptor,"rule term");
		RewriteRuleSubtreeStream stream_compositeid=new RewriteRuleSubtreeStream(adaptor,"rule compositeid");

		try {
			// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:117:5: ( compositeid '(' term ( ',' term )* ')' -> ^( ATOM compositeid ( term )* ) )
			// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:118:3: compositeid '(' term ( ',' term )* ')'
			{
			pushFollow(FOLLOW_compositeid_in_atom311);
			compositeid25=compositeid();
			state._fsp--;

			stream_compositeid.add(compositeid25.getTree());
			char_literal26=(Token)match(input,20,FOLLOW_20_in_atom313);  
			stream_20.add(char_literal26);

			pushFollow(FOLLOW_term_in_atom315);
			term27=term();
			state._fsp--;

			stream_term.add(term27.getTree());
			// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:118:24: ( ',' term )*
			loop7:
			while (true) {
				int alt7=2;
				int LA7_0 = input.LA(1);
				if ( (LA7_0==22) ) {
					alt7=1;
				}

				switch (alt7) {
				case 1 :
					// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:118:25: ',' term
					{
					char_literal28=(Token)match(input,22,FOLLOW_22_in_atom318);  
					stream_22.add(char_literal28);

					pushFollow(FOLLOW_term_in_atom320);
					term29=term();
					state._fsp--;

					stream_term.add(term29.getTree());
					}
					break;

				default :
					break loop7;
				}
			}

			char_literal30=(Token)match(input,21,FOLLOW_21_in_atom324);  
			stream_21.add(char_literal30);

			// AST REWRITE
			// elements: compositeid, term
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (Object)adaptor.nil();
			// 118:40: -> ^( ATOM compositeid ( term )* )
			{
				// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:118:43: ^( ATOM compositeid ( term )* )
				{
				Object root_1 = (Object)adaptor.nil();
				root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(ATOM, "ATOM"), root_1);
				adaptor.addChild(root_1, stream_compositeid.nextTree());
				// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:118:62: ( term )*
				while ( stream_term.hasNext() ) {
					adaptor.addChild(root_1, stream_term.nextTree());
				}
				stream_term.reset();

				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (Object)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
			retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "atom"


	public static class compositeid_return extends ParserRuleReturnScope {
		Object tree;
		@Override
		public Object getTree() { return tree; }
	};


	// $ANTLR start "compositeid"
	// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:120:1: compositeid : ( id ) ':' ( id ) -> ^( ID id id ) ;
	public final ConjunctiveQueryParser.compositeid_return compositeid() throws RecognitionException {
		ConjunctiveQueryParser.compositeid_return retval = new ConjunctiveQueryParser.compositeid_return();
		retval.start = input.LT(1);

		Object root_0 = null;

		Token char_literal32=null;
		ParserRuleReturnScope id31 =null;
		ParserRuleReturnScope id33 =null;

		Object char_literal32_tree=null;
		RewriteRuleTokenStream stream_24=new RewriteRuleTokenStream(adaptor,"token 24");
		RewriteRuleSubtreeStream stream_id=new RewriteRuleSubtreeStream(adaptor,"rule id");

		try {
			// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:120:12: ( ( id ) ':' ( id ) -> ^( ID id id ) )
			// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:121:2: ( id ) ':' ( id )
			{
			// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:121:2: ( id )
			// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:121:3: id
			{
			pushFollow(FOLLOW_id_in_compositeid344);
			id31=id();
			state._fsp--;

			stream_id.add(id31.getTree());
			}

			char_literal32=(Token)match(input,24,FOLLOW_24_in_compositeid347);  
			stream_24.add(char_literal32);

			// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:121:11: ( id )
			// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:121:12: id
			{
			pushFollow(FOLLOW_id_in_compositeid350);
			id33=id();
			state._fsp--;

			stream_id.add(id33.getTree());
			}

			// AST REWRITE
			// elements: id, id
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (Object)adaptor.nil();
			// 121:16: -> ^( ID id id )
			{
				// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:121:19: ^( ID id id )
				{
				Object root_1 = (Object)adaptor.nil();
				root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(ID, "ID"), root_1);
				adaptor.addChild(root_1, stream_id.nextTree());
				adaptor.addChild(root_1, stream_id.nextTree());
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (Object)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
			retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "compositeid"


	public static class term_return extends ParserRuleReturnScope {
		Object tree;
		@Override
		public Object getTree() { return tree; }
	};


	// $ANTLR start "term"
	// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:124:1: term : ( variable -> ^( VARIABLE variable ) | id -> ^( SCONSTANT id ) );
	public final ConjunctiveQueryParser.term_return term() throws RecognitionException {
		ConjunctiveQueryParser.term_return retval = new ConjunctiveQueryParser.term_return();
		retval.start = input.LT(1);

		Object root_0 = null;

		ParserRuleReturnScope variable34 =null;
		ParserRuleReturnScope id35 =null;

		RewriteRuleSubtreeStream stream_variable=new RewriteRuleSubtreeStream(adaptor,"rule variable");
		RewriteRuleSubtreeStream stream_id=new RewriteRuleSubtreeStream(adaptor,"rule id");

		try {
			// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:124:5: ( variable -> ^( VARIABLE variable ) | id -> ^( SCONSTANT id ) )
			int alt8=2;
			int LA8_0 = input.LA(1);
			if ( (LA8_0==27) ) {
				alt8=1;
			}
			else if ( (LA8_0==STRING||LA8_0==URLSTRING) ) {
				alt8=2;
			}

			else {
				NoViableAltException nvae =
					new NoViableAltException("", 8, 0, input);
				throw nvae;
			}

			switch (alt8) {
				case 1 :
					// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:125:3: variable
					{
					pushFollow(FOLLOW_variable_in_term373);
					variable34=variable();
					state._fsp--;

					stream_variable.add(variable34.getTree());
					// AST REWRITE
					// elements: variable
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (Object)adaptor.nil();
					// 125:12: -> ^( VARIABLE variable )
					{
						// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:125:15: ^( VARIABLE variable )
						{
						Object root_1 = (Object)adaptor.nil();
						root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(VARIABLE, "VARIABLE"), root_1);
						adaptor.addChild(root_1, stream_variable.nextTree());
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;
				case 2 :
					// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:125:38: id
					{
					pushFollow(FOLLOW_id_in_term385);
					id35=id();
					state._fsp--;

					stream_id.add(id35.getTree());
					// AST REWRITE
					// elements: id
					// token labels: 
					// rule labels: retval
					// token list labels: 
					// rule list labels: 
					// wildcard labels: 
					retval.tree = root_0;
					RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

					root_0 = (Object)adaptor.nil();
					// 125:40: -> ^( SCONSTANT id )
					{
						// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:125:43: ^( SCONSTANT id )
						{
						Object root_1 = (Object)adaptor.nil();
						root_1 = (Object)adaptor.becomeRoot((Object)adaptor.create(SCONSTANT, "SCONSTANT"), root_1);
						adaptor.addChild(root_1, stream_id.nextTree());
						adaptor.addChild(root_0, root_1);
						}

					}


					retval.tree = root_0;

					}
					break;

			}
			retval.stop = input.LT(-1);

			retval.tree = (Object)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
			retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "term"


	public static class id_return extends ParserRuleReturnScope {
		Object tree;
		@Override
		public Object getTree() { return tree; }
	};


	// $ANTLR start "id"
	// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:127:1: id : ( URLSTRING | STRING ) ;
	public final ConjunctiveQueryParser.id_return id() throws RecognitionException {
		ConjunctiveQueryParser.id_return retval = new ConjunctiveQueryParser.id_return();
		retval.start = input.LT(1);

		Object root_0 = null;

		Token set36=null;

		Object set36_tree=null;

		try {
			// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:127:4: ( ( URLSTRING | STRING ) )
			// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:
			{
			root_0 = (Object)adaptor.nil();


			set36=input.LT(1);
			if ( input.LA(1)==STRING||input.LA(1)==URLSTRING ) {
				input.consume();
				adaptor.addChild(root_0, (Object)adaptor.create(set36));
				state.errorRecovery=false;
			}
			else {
				MismatchedSetException mse = new MismatchedSetException(null,input);
				throw mse;
			}
			}

			retval.stop = input.LT(-1);

			retval.tree = (Object)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
			retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "id"


	public static class variable_return extends ParserRuleReturnScope {
		Object tree;
		@Override
		public Object getTree() { return tree; }
	};


	// $ANTLR start "variable"
	// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:130:1: variable : ( '?' ) id -> ^( id ) ;
	public final ConjunctiveQueryParser.variable_return variable() throws RecognitionException {
		ConjunctiveQueryParser.variable_return retval = new ConjunctiveQueryParser.variable_return();
		retval.start = input.LT(1);

		Object root_0 = null;

		Token char_literal37=null;
		ParserRuleReturnScope id38 =null;

		Object char_literal37_tree=null;
		RewriteRuleTokenStream stream_27=new RewriteRuleTokenStream(adaptor,"token 27");
		RewriteRuleSubtreeStream stream_id=new RewriteRuleSubtreeStream(adaptor,"rule id");

		try {
			// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:130:9: ( ( '?' ) id -> ^( id ) )
			// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:131:3: ( '?' ) id
			{
			// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:131:3: ( '?' )
			// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:131:4: '?'
			{
			char_literal37=(Token)match(input,27,FOLLOW_27_in_variable416);  
			stream_27.add(char_literal37);

			}

			pushFollow(FOLLOW_id_in_variable419);
			id38=id();
			state._fsp--;

			stream_id.add(id38.getTree());
			// AST REWRITE
			// elements: id
			// token labels: 
			// rule labels: retval
			// token list labels: 
			// rule list labels: 
			// wildcard labels: 
			retval.tree = root_0;
			RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.getTree():null);

			root_0 = (Object)adaptor.nil();
			// 131:12: -> ^( id )
			{
				// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:131:15: ^( id )
				{
				Object root_1 = (Object)adaptor.nil();
				root_1 = (Object)adaptor.becomeRoot(stream_id.nextNode(), root_1);
				adaptor.addChild(root_0, root_1);
				}

			}


			retval.tree = root_0;

			}

			retval.stop = input.LT(-1);

			retval.tree = (Object)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
			retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "variable"


	public static class url_return extends ParserRuleReturnScope {
		Object tree;
		@Override
		public Object getTree() { return tree; }
	};


	// $ANTLR start "url"
	// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:133:1: url : ( URLSTRING ) ;
	public final ConjunctiveQueryParser.url_return url() throws RecognitionException {
		ConjunctiveQueryParser.url_return retval = new ConjunctiveQueryParser.url_return();
		retval.start = input.LT(1);

		Object root_0 = null;

		Token URLSTRING39=null;

		Object URLSTRING39_tree=null;

		try {
			// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:133:5: ( ( URLSTRING ) )
			// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:133:7: ( URLSTRING )
			{
			root_0 = (Object)adaptor.nil();


			// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:133:7: ( URLSTRING )
			// /Users/giorgiostefanoni/svn/DL2012-Stefanoni/EOLO/src/uk/ac/ox/eolo/cqparser/ConjunctiveQuery.g:133:8: URLSTRING
			{
			URLSTRING39=(Token)match(input,URLSTRING,FOLLOW_URLSTRING_in_url436); 
			URLSTRING39_tree = (Object)adaptor.create(URLSTRING39);
			adaptor.addChild(root_0, URLSTRING39_tree);

			}

			}

			retval.stop = input.LT(-1);

			retval.tree = (Object)adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

		}
		catch (RecognitionException re) {
			reportError(re);
			recover(input,re);
			retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);
		}
		finally {
			// do for sure before leaving
		}
		return retval;
	}
	// $ANTLR end "url"

	// Delegated rules



	public static final BitSet FOLLOW_prefixlist_in_cq133 = new BitSet(new long[]{0x0000000000028000L});
	public static final BitSet FOLLOW_rulebody_in_cq135 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_prefix_in_prefixlist155 = new BitSet(new long[]{0x0000000000400002L});
	public static final BitSet FOLLOW_22_in_prefixlist158 = new BitSet(new long[]{0x0000000030000000L});
	public static final BitSet FOLLOW_prefix_in_prefixlist160 = new BitSet(new long[]{0x0000000000400002L});
	public static final BitSet FOLLOW_29_in_prefix183 = new BitSet(new long[]{0x0000000000028000L});
	public static final BitSet FOLLOW_28_in_prefix185 = new BitSet(new long[]{0x0000000000028000L});
	public static final BitSet FOLLOW_id_in_prefix188 = new BitSet(new long[]{0x0000000001000000L});
	public static final BitSet FOLLOW_24_in_prefix190 = new BitSet(new long[]{0x0000000000020000L});
	public static final BitSet FOLLOW_url_in_prefix193 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_headatom_in_rulebody215 = new BitSet(new long[]{0x0000000006000000L});
	public static final BitSet FOLLOW_26_in_rulebody218 = new BitSet(new long[]{0x0000000000028000L});
	public static final BitSet FOLLOW_25_in_rulebody220 = new BitSet(new long[]{0x0000000000028000L});
	public static final BitSet FOLLOW_body_in_rulebody223 = new BitSet(new long[]{0x0000000000800002L});
	public static final BitSet FOLLOW_23_in_rulebody225 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_atom_in_body247 = new BitSet(new long[]{0x0000000000400002L});
	public static final BitSet FOLLOW_22_in_body250 = new BitSet(new long[]{0x0000000000028000L});
	public static final BitSet FOLLOW_atom_in_body252 = new BitSet(new long[]{0x0000000000400002L});
	public static final BitSet FOLLOW_id_in_headatom278 = new BitSet(new long[]{0x0000000000100000L});
	public static final BitSet FOLLOW_20_in_headatom280 = new BitSet(new long[]{0x0000000008028000L});
	public static final BitSet FOLLOW_term_in_headatom282 = new BitSet(new long[]{0x0000000000600000L});
	public static final BitSet FOLLOW_22_in_headatom285 = new BitSet(new long[]{0x0000000008028000L});
	public static final BitSet FOLLOW_term_in_headatom287 = new BitSet(new long[]{0x0000000000600000L});
	public static final BitSet FOLLOW_21_in_headatom291 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_compositeid_in_atom311 = new BitSet(new long[]{0x0000000000100000L});
	public static final BitSet FOLLOW_20_in_atom313 = new BitSet(new long[]{0x0000000008028000L});
	public static final BitSet FOLLOW_term_in_atom315 = new BitSet(new long[]{0x0000000000600000L});
	public static final BitSet FOLLOW_22_in_atom318 = new BitSet(new long[]{0x0000000008028000L});
	public static final BitSet FOLLOW_term_in_atom320 = new BitSet(new long[]{0x0000000000600000L});
	public static final BitSet FOLLOW_21_in_atom324 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_id_in_compositeid344 = new BitSet(new long[]{0x0000000001000000L});
	public static final BitSet FOLLOW_24_in_compositeid347 = new BitSet(new long[]{0x0000000000028000L});
	public static final BitSet FOLLOW_id_in_compositeid350 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_variable_in_term373 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_id_in_term385 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_27_in_variable416 = new BitSet(new long[]{0x0000000000028000L});
	public static final BitSet FOLLOW_id_in_variable419 = new BitSet(new long[]{0x0000000000000002L});
	public static final BitSet FOLLOW_URLSTRING_in_url436 = new BitSet(new long[]{0x0000000000000002L});
}
