package uk.ac.ox.eolo.model;


public class EoloPrefixes {

	public static final String IND_PREFIX = "eolo-ind:";
	public static final String IND_URI = "http://www.cs.ox.ac.uk/EOLO/eolo-ind.owl#";
	
	public static final String AUX_PREFIX = "eolo-aux:";
	public static final String AUX_URI = "http://www.cs.ox.ac.uk/EOLO/eolo-aux.owl#";
	
	public static final String SELF_PREFIX = "eolo-self:";
	public static final String SELF_URI = "http://www.cs.ox.ac.uk/EOLO/eolo-self.owl#";
	
	public static final String DIRECT_PREFIX = "eolo-direct:";
	public static final String DIRECT_URI = "http://www.cs.ox.ac.uk/EOLO/eolo-direct.owl#";
	
	
	public static final String ONTO_PREFIX = "eolo-onto:";
	
	public static String getDeclaration() {
		return "PREFIX " + IND_PREFIX +  " <" + IND_URI +">\n" +
				"PREFIX " + AUX_PREFIX +  " <" + AUX_URI +">\n" +
				"PREFIX " + SELF_PREFIX +  " <" + SELF_URI +">\n" +
				"PREFIX " + DIRECT_PREFIX +  " <" + DIRECT_URI +">\n";
	}

}
